#ifndef _KERNEL_BLK_H
#define _KERNEL_BLK_H 1
//----------------------------------------------------------------------
#include <sys/types.h>
#include <kernel/driver/ata.h>
//----------------------------------------------------------------------
#define BLK_SIZE          ATA_SECTOR_SIZE         // [1]
//
// [1] This value should be the same as the mass memory sector size,
//     or a multiple. But with a multiple, all simple read and write
//     will be doubled, and some race will lock the system, because
//     read and write are too frequent for the poor ATA driver that
//     I have. :-(
//
//----------------------------------------------------------------------
#define BLK_CACHE_SIZE          128     // This is free!
#define BLK_CACHE_MAX_AGE       BLK_CACHE_SIZE-1
typedef struct {
    unsigned int age;           // 0=last used DEV_CACHE_MAX_AGE=older
    dev_t        device;
    unsigned int n;
    char         block[BLK_SIZE];
} blk_cache_t;

extern blk_cache_t   blk_table[BLK_CACHE_SIZE];
//----------------------------------------------------------------------
void *blk_ata (dev_t device, int rw, unsigned int n, void *buffer);
//----------------------------------------------------------------------
void  blk_cache_init  (void);
void  blk_cache_check (void);
void *blk_cache_read  (dev_t device, unsigned int n);
void *blk_cache_save  (dev_t device, unsigned int n, void *block);
//----------------------------------------------------------------------

#endif
