#include <kernel/driver/ata.h>
#include <errno.h>
//----------------------------------------------------------------------
int
ata_valid (int drive)
{
    //
    // Verify if `drive' argument is possible.
    //
    if (drive < 0 || drive >= ATA_MAX_DEVICES)
      {
        errset (EINVAL);
        return (-1);
      }
    //
    // Verify if `drive' is present at the moment.
    //
    if (ata_table[drive].present == 0)
      {
        errset (E_NO_MEDIUM);
        return (-1);
      }
    //
    // OK.
    //
    return (0);
}
