#include <kernel/driver/pci.h>
#include <kernel/driver/nic/ne2k.h>
#include <kernel/ibm_i386.h>
#include <errno.h>
#include <kernel/lib_k.h>
#include <kernel/lib_s.h>
//----------------------------------------------------------------------
int
ne2k_isr (uintptr_t io)
{
  int       isr;
  //
  // Get ISR (interrupt status register).
  //
  isr = in_8 (io + NE2K_ISR);
  //
  //
  //
  if (isr & 0x01)
    {
      //
      // Frame received.
      //
      out_8 (io + NE2K_ISR, 0x01);
      ne2k_rx (io);
    }
  if (isr & 0x04)
    {
      //
      // Frame received with errors.
      //
      out_8 (io + NE2K_ISR, 0x04);
    }
  if (isr & 0x02)
    {
      //
      // Frame sent correctly.
      //
      ;
    }
  if (isr & 0x08)
    {
      //
      // Frame sent with errors.
      //
      ;
    }
  if (isr & 0x10)
    {
     k_printf ("OVERWRITE\n");
     out_8 (io + NE2K_ISR, 0x10);
     //
     // I don't understand if it works: Bochs just don't accept
     // frames if they can make an overflow.
     //
     ne2k_rx (io);
     ne2k_rx_reset (io);
    }
  if (isr & 0x20)
    {
     //
     // Counter overflow.
     //
     out_8 (io + NE2K_ISR, 0x20);
    }
  if (isr & 0x40)
    {
     //
     // Remote DMA complete.
     //
     ;
    }
  if (isr & 0x80)
    {
     //
     // Reset status.
     //
     ;
    }
  //
  // End.
  //
  return (0);
}
