#include <kernel/driver/screen.h>
#include <errno.h>
//----------------------------------------------------------------------
int
screen_scroll (screen_t *screen)
{
    int a;              // screen[].cell[] index.
    int b;              // screen[].cell[] index
    //
    // Check argument.
    //
    if (screen == NULL)
      {
        errset (EINVAL);
        return (-1);
      }
    //
    // Move up a line.
    //
    for (a = 0, b = SCREEN_COLS; b < SCREEN_CELLS; a++, b++)
      {
        screen->cell[a] = screen->cell[b];
      }
    //
    // Clear last screen line.
    //
    for (b = (SCREEN_CELLS - SCREEN_COLS); b < SCREEN_CELLS; b++)
      {
        screen->cell[b] = screen_cell (' ', VGA_ATTR);
      }
    //
    // Update position.
    //
    screen->position -= SCREEN_COLS;
    if (screen->position < 0)
      {
        screen->position = 0;
      }
    //
    // Update the video if it is the current one.
    //
    screen_update (screen);
    //
    // Ok.
    //
    return (0);
}
