#include <kernel/lib_s.h>
#include <kernel/proc.h>
#include <errno.h>
#include <sys/os32.h>
//----------------------------------------------------------------------
extern uint32_t proc_stack_pointer;
//----------------------------------------------------------------------
void
s_longjmp (pid_t pid, jmp_buf env, int val)
{
  jmp_stack_t *sp;
  jmp_env_t   *jmpenv;
  //
  // Translate the pointer `env', to the kernel point of view.
  //
  jmpenv = proc_offset_data_to_pointer (pid, (addr_t) env);
  //
  // Find where *was* the process stack in memory, from the kernel point
  // of view. Please notice that the current stack at
  // `proc_stack_pointer' will be saved from the scheduler inside
  // the process table. So, the replacement is made at the current
  // stack position, and not inside the process table.
  //
  sp = proc_offset_data_to_pointer (pid, jmpenv->esp0);
  //
  // Restore the process stack.
  //
  sp->eax0    = jmpenv->eax0;
  sp->ecx0    = jmpenv->ecx0;
  sp->edx0    = jmpenv->edx0;
  sp->ebx0    = jmpenv->ebx0;
  sp->ebp0    = jmpenv->ebp0;
  sp->esi0    = jmpenv->esi0;
  sp->edi0    = jmpenv->edi0;
  sp->ds0     = jmpenv->ds0;
  sp->es0     = jmpenv->es0;
  sp->fs0     = jmpenv->fs0;
  sp->gs0     = jmpenv->gs0;
  sp->eflags0 = jmpenv->eflags0;
  sp->cs0     = jmpenv->cs0;
  sp->eip0    = jmpenv->eip0;
  //
  sp->eip1        = jmpenv->eip1;
  sp->syscallnr   = jmpenv->syscallnr;
  sp->msg_pointer = jmpenv->msg_pointer;
  sp->msg_size    = jmpenv->msg_size;
  sp->env         = jmpenv->env;
  sp->ret         = val;
  sp->ebp1        = jmpenv->ebp1;
  sp->eip2        = jmpenv->eip2;
  //
  // Replace the stack pointer too!
  //
  proc_stack_pointer = jmpenv->esp0;
}
