#include <kernel/lib_s.h>
#include <kernel/proc.h>
#include <errno.h>
#include <setjmp.h>
//----------------------------------------------------------------------
extern uint32_t proc_stack_pointer;
//----------------------------------------------------------------------
int
s_setjmp (pid_t pid, jmp_buf env)
{
  jmp_stack_t  *sp;
  jmp_env_t    *jmpenv;
  //
  // Find where is the process stack in memory, from the kernel point
  // of view. Please notice that the current stack at
  // `proc_stack_pointer' will be saved from the scheduler inside
  // the process table, and current stack saved inside the process
  // table is not up to date.
  //
  sp = proc_offset_data_to_pointer (pid, proc_stack_pointer);
  //
  // Translate the pointer `env', to the kernel point of view.
  //
  jmpenv = proc_offset_data_to_pointer (pid, (addr_t) env);
  //
  // Save the process stack.
  //
  jmpenv->eax0    = sp->eax0;
  jmpenv->ecx0    = sp->ecx0;
  jmpenv->edx0    = sp->edx0;
  jmpenv->ebx0    = sp->ebx0;
  jmpenv->ebp0    = sp->ebp0;
  jmpenv->esi0    = sp->esi0;
  jmpenv->edi0    = sp->edi0;
  jmpenv->ds0     = sp->ds0;
  jmpenv->es0     = sp->es0;
  jmpenv->fs0     = sp->fs0;
  jmpenv->gs0     = sp->gs0;
  jmpenv->eflags0 = sp->eflags0;
  jmpenv->cs0     = sp->cs0;
  jmpenv->eip0    = sp->eip0;
  //
  jmpenv->eip1          = sp->eip1;
  jmpenv->syscallnr     = sp->syscallnr;
  jmpenv->msg_pointer   = sp->msg_pointer;
  jmpenv->msg_size      = sp->msg_size;
  jmpenv->env           = sp->env;
  jmpenv->ret           = sp->ret;
  jmpenv->ebp1          = sp->ebp1;
  jmpenv->eip2          = sp->eip2;
  //
  // Save also the stack pointer!
  //
  jmpenv->esp0    = proc_stack_pointer;
  //
  return 0;
}
