#ifndef _KERNEL_MEMORY_H
#define _KERNEL_MEMORY_H       1
//----------------------------------------------------------------------
#include <stdint.h>
#include <stddef.h>
#include <sys/types.h>
//----------------------------------------------------------------------
#define MEM_BLOCK_SIZE  0x1000    // 4 Ki/block
#define MEM_MAX_BLOCKS  0x100000  // 1 Mi blocks = 4 Gibyte

extern uint32_t     mb_table[MEM_MAX_BLOCKS/32]; // Memory blocks map.
extern unsigned int mb_max;                      // Memory blocks max.
//----------------------------------------------------------------------
typedef unsigned int       addr_t;
//----------------------------------------------------------------------
uint32_t *mb_reference  (void);
ssize_t   mb_alloc      (addr_t address, size_t size);
void      mb_free       (addr_t address, size_t size);
int       mb_reduce     (addr_t address, size_t new, size_t previous);
void      mb_clean      (addr_t address, size_t size);
addr_t    mb_alloc_size (size_t size);
void      mb_print      (void);
void      mb_size       (size_t size);
//----------------------------------------------------------------------
#endif
