#include <sys/os32.h>
#include <kernel/net/ethernet.h>
#include <kernel/driver/nic/ne2k.h>
#include <kernel/driver/pci.h>
#include <kernel/ibm_i386.h>
#include <errno.h>
//----------------------------------------------------------------------
int
ethernet_tx (int n, void *buffer, size_t size)
{
  //
  if (n >= NET_MAX_DEVICES || n < 0)
    {
      errset (EINVAL);
      return (-1);
    }
  if (!(net_table[n].type & NET_DEV_ETH))
    {
      errset (EINVAL);
      return (-1);
    }
  //
  if (net_table[n].type == NET_DEV_ETH_NE2K)
    {
      return (ne2k_tx (net_table[n].ethernet.base_io, buffer, size));
    }
  //
  // If we are here, there is not the driver for the Ethernet device.
  //
  errset (ENODEV);
  return (-1);
}
