#include <stdint.h>
#include <arpa/inet.h>
#include <kernel/net/ip.h>
//----------------------------------------------------------------------
uint16_t
ip_checksum (uint16_t *data, size_t size)
{
  int      i;
  uint32_t sum;
  uint16_t carry;
  uint16_t checksum;
  uint16_t last;
  uint8_t *octet = (uint8_t *) data;
  //
  // 2's complement sum.
  //
  for (i = 0, sum = 0; i < (size/2); i++)
    {
      sum += ntohs (data[i]);
    }
  //
  if (size % 2)
    {
      //
      // The size is odd, and the last octet must be accounted too.
      //
      last = octet[size-1];
      last = last << 8;
      //
      sum += last;
    }
  //
  // Extract the carries and make the checksum.
  //
  carry    = sum >> 16;
  checksum = sum & 0x0000FFFF;
  checksum += carry;
  //
  // End of job.
  //
  return (checksum);
}
