#include <kernel/net.h>
#include <kernel/net/ip.h>
#include <sys/os32.h>
#include <kernel/lib_k.h>
#include <errno.h>
#include <arpa/inet.h>
//----------------------------------------------------------------------
#define DEBUG 0
//----------------------------------------------------------------------
int
ip_tx (h_addr_t src, h_addr_t dst, int protocol, const void *buffer,
       size_t size)
{
  static int  id = 0;
  ip_packet_t packet;
  uint16_t    checksum;
  //
  // Prepare the packet.
  //
  packet.version         = IP_VERSION;
  packet.header_length   = sizeof (net_ip_header_t) / 4;
  packet.service         = 0x0000;                  // Routine, normal.
  packet.length          = htons (sizeof (net_ip_header_t) + size);
  packet.id              = htons (id++);
  packet.fragment        = htons (0x4000);           // Do not fragment!
  packet.ttl             = IP_TTL;
  packet.protocol        = protocol;
  packet.header_checksum = 0;
  packet.src             = htonl (src);
  packet.dst             = htonl (dst);
  //
  // Now set the header checksum.
  //
  checksum = ~(ip_checksum ((void *) &packet, sizeof (net_ip_header_t)));
  packet.header_checksum = htons (checksum);
  //
  memcpy (packet.data, buffer, size);
  //
  // Send to the lower network level.
  //
  return (net_ip_tx (src, dst, (void *) &packet,
                     (sizeof (net_ip_header_t) + size)));
}
