#include <kernel/proc.h>
#include <kernel/lib_k.h>
#include <kernel/lib_s.h>
#include <kernel/driver/nic/ne2k.h>
#include <kernel/net.h>
#include <kernel/driver/pci.h>
//----------------------------------------------------------------------
void
proc_sch_net (void)
{
  int n;                // NET table index.
  int counter = 0;
  int pid;
  //
  // Do what there is to do with network interfaces, in particular get
  // received frames, into the `net_table[n]...buffer[f]' table.
  //
  for (n = 0; n < NET_MAX_DEVICES; n++)
    {
      if (net_table[n].type == NET_DEV_ETH_NE2K)
        {
          //
          // The function `ne2k_isr()' will call also `ne2k_rx()'
          // that is responsible for placing Ethernet frames inside
          // `ethernet_table[eth].frame_info[f]'.
          //
          ne2k_isr (net_table[n].ethernet.base_io);
        }
      else if (net_table[n].type == NET_DEV_LOOPBACK)
        {
          //
          // Packets should be already inside the packet buffer table.
          //
          ;
        }
    }
  //
  // Do something with received Ethernet frames: the function
  // `net_rx()' will report how many frames was received.
  //
  counter = net_rx ();
  //
  // If there are received packets, must do something with
  // sleeping process.
  //
  for (pid = 1; pid < PROCESS_MAX; pid++)
    {
      if (proc_table[pid].status == PROC_SLEEPING
          && (proc_table[pid].wakeup_events
              & WAKEUP_EVENT_SOCK_READ))
          {
            proc_table[pid].wakeup_events = 0;
            proc_table[pid].status        = PROC_READY;
          }
    }
}
