#include <kernel/proc.h>
//----------------------------------------------------------------------
void
proc_wakeup_terminal (void)
{
    pid_t pid;
    //
    // At the moment, all processes waiting for reading
    // a terminal are reactivated.
    //
    for (pid = 0; pid < PROCESS_MAX; pid++)
      {
        if (   (proc_table[pid].status == PROC_SLEEPING)
            && (proc_table[pid].wakeup_events & WAKEUP_EVENT_TTY))
          {
            //
            // A process waiting for that terminal was found:
            // remove the waiting event and set it ready.
            //
            proc_table[pid].wakeup_events &= ~WAKEUP_EVENT_TTY;
            proc_table[pid].status = PROC_READY;
          }
      }
}
