#include <grp.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//----------------------------------------------------------------------
static char          buffer[BUFSIZ];
static struct group  gr;
static FILE         *fp = NULL;
//----------------------------------------------------------------------
struct group *
getgrent (void)
{
    void *pstatus;
    char *char_gid;
    int   i;
    //
    if (fp == NULL)
      {
        fp = fopen ("/etc/group", "r");
        if (fp == NULL)
          {
            return NULL;
          }
      }
    //
    pstatus = fgets (buffer, BUFSIZ, fp);
    if (pstatus == NULL)
      {
        return (NULL);
      }
    //
    // The parse is made with `strtok()'. Please notice that
    // `strtok()' will not parse a line like the following:
    //   user::233:
    // The password field *must* have something, otherwise the
    // GID will take the password place.
    // `strtok()' will consider `::' the same as `:'!
    //
    gr.gr_name   = strtok (buffer, ":");
    gr.gr_passwd = strtok (NULL, ":");
    char_gid     = strtok (NULL, ":");
    for (i = 0; i < GR_MEM_MAX; i++)
      {
        gr.gr_mem[i] = strtok (NULL, ",\n");
      }
    gr.gr_gid    = (gid_t) atoi (char_gid);
    //
    return (&gr);
}
//----------------------------------------------------------------------
void
endgrent (void)
{
    int status;
    //
    if (fp != NULL)
      {
        status = fclose (fp);
        if (status != 0)
          {
            perror (NULL);
            fp = NULL;
          }
      }
}
//----------------------------------------------------------------------
void
setgrent (void)
{
    if (fp != NULL)
      {
        rewind (fp);
      }
}
//----------------------------------------------------------------------
struct group *
getgrnam (const char *name)
{
    struct group *gr;
    //
    setgrent ();
    //
    for (;;)
      {
        gr = getgrent ();
        if (gr == NULL)
          {
            return (NULL);
          }
        if (strcmp (gr->gr_name, name) == 0)
          {
            return (gr);
          }
      }
}
//----------------------------------------------------------------------
struct group *
getgrgid (gid_t gid)
{
    struct group *gr;
    //
    setgrent ();
    //
    for (;;)
      {
        gr = getgrent ();
        if (gr == NULL)
          {
            return (NULL);
          }
        if (gr->gr_gid == gid)
          {
            return (gr);
          }
      }
}
