.global _sighandler_wrapper
#-----------------------------------------------------------------------
.section .text
#-----------------------------------------------------------------------
# Port input byte.
#-----------------------------------------------------------------------
_sighandler_wrapper:
    #
    # Current stack is:
    #
    # push %eip                 # Back from interrupted code.
    # push <sig_num>            # Signal number.
    # push <sig_handler>        # Signal handler address
    #
    # Please note that THERE IS NO RETURN ADDRESS! Instead
    # you find the signal handler address there.
    #
    # This routine should have to call the signal handler
    # function, and then return back to the interrupted code.
    #
    enter $0, $0                # No local variables.
    pushf
    pusha
    .equ SIG_HAND,  4           # First argument.  [1]
    .equ SIG_NUM,   8           # Second argument. [1]
    #
    # [1] This function is called without the return address inside
    #     the stack. So the arguments are 4 bytes nearer than the
    #     usual.
    #
    mov  SIG_NUM(%ebp), %edx    # Copy the signal number into EDX.
    mov  SIG_HAND(%ebp), %eax   # Copy the signal handler function
                                #  address into EAX.
    push %edx                   # Prepare argument for the signal
                                #  handler function.
    call *%eax                  # Call the signal handler function.
                                #
    add  $4, %esp               # Pop the signal number argument.
                                #
    popa
    popf
    leave
    #
    # Now we are back to the same stack as the beginning:
    #
    # push %eip         # back from interrupted code.
    # push <sig_num>
    # push <sig_handler>
    # push %eip         # back from _sighandler_wrapper()
    #
    # The stack pointer must be modified before returning,
    # so that the address to the original interrupted instruction
    # is used for return. Without such modification, the RET
    # instruction would find the signal handler address instead!
    #
    add $4, %esp
    add $4, %esp
    #
    # Now we are ready to return to the original interrupted
    # address!
    #
    ret

