#include <fcntl.h>
#include <stdarg.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/os32.h>
#include <limits.h>
#include <stdio.h>
//----------------------------------------------------------------------
FILE *
freopen (const char *restrict path, const char *restrict mode,
         FILE *restrict fp)
{
    int   status;
    FILE *fp_new;
    //
    if (fp == NULL)
      {
        return (NULL);
      }
    //
    status = fclose (fp);
    if (status != 0)
      {
        fp->error = 1;
        return (NULL);
      }
    //
    fp_new = fopen (path, mode);
    //
    if (fp_new == NULL)
      {
        return (NULL);
      }
    //    
    if (fp_new != fp)
      {
	fclose (fp_new);
	return (NULL);
      }
    //
    return (fp_new);
}
