#ifndef _SYS_SOCKET_H
#define _SYS_SOCKET_H    1
//----------------------------------------------------------------------
#include <stdint.h>
#include <unistd.h>
#include <sys/socklen_t.h>
#include <sys/sa_family_t.h>
//----------------------------------------------------------------------
struct sockaddr {
  sa_family_t sa_family;    // Address family.
  char        sa_data[14];  // Socket address.
};
//
//
//
struct sockaddr_storage {
  sa_family_t ss_family;    // Socket storage family.
  uint8_t     ss_zero[14];  // Filler.
};
//
//
//
#define SOCK_STREAM    1  // Byte-stream socket.
#define SOCK_DGRAM     2  // Datagram socket.
#define SOCK_RAW       3  // Raw protocol interface.
#define SOCK_SEQPACKET 5  // Sequenced-packet socket.



#define AF_UNSPEC  0 // Unspecified.
#define AF_UNIX    1 // Unix domain socket.
#define AF_INET    2 // IPv4 protocol family.
#define AF_INET6  10 // IPv6 protocol family.

//----------------------------------------------------------------------
int     connect (int sfdn, const struct sockaddr *addr,
                 socklen_t addrlen);
ssize_t send    (int sfdn, const void *buffer, size_t count, int flags);
ssize_t recv    (int sfdn, void *buffer, size_t count, int flags);
int     socket  (int family, int type, int protocol);
//----------------------------------------------------------------------
#endif
