#include <termios.h>
#include <sys/os32.h>
#include <errno.h>
//----------------------------------------------------------------------
int
tcgetattr (int fdn, struct termios *termios_p)
{
  sysmsg_tcattr_t msg;
  int             c;
  //
  if (termios_p == NULL)
    {
      errset (EINVAL);
      return (-1);
    }
  //
  // System call.
  //
  sys (SYS_TCGETATTR, &msg, (sizeof msg));
  //
  termios_p->c_iflag = msg.attr.c_iflag;
  termios_p->c_oflag = msg.attr.c_oflag;
  termios_p->c_cflag = msg.attr.c_cflag;
  termios_p->c_lflag = msg.attr.c_lflag;
  //
  for (c = 0; c < NCCS; c++)
  {
    termios_p->c_cc[c] = msg.attr.c_cc[c];
  }
  //
  errno = msg.errno;
  errln = msg.errln;
  strncpy (errfn, msg.errfn, PATH_MAX);
  return (msg.ret);
}
