#include <termios.h>
#include <sys/os32.h>
#include <errno.h>
//----------------------------------------------------------------------
#define DEBUG 0
//----------------------------------------------------------------------
int
tcsetattr (int fdn, int action, struct termios *termios_p)
{
  sysmsg_tcattr_t msg;
  int             c;
  //
  if (termios_p == NULL)
    {
      errset (EINVAL);
      return (-1);
    }
  //
  msg.action = action;
  //
  msg.attr.c_iflag = termios_p->c_iflag;
  msg.attr.c_oflag = termios_p->c_oflag;
  msg.attr.c_cflag = termios_p->c_cflag;
  msg.attr.c_lflag = termios_p->c_lflag;
  //
  for (c = 0; c < NCCS; c++)
  {
    msg.attr.c_cc[c] = termios_p->c_cc[c];
  }
  //
  // Debug?
  //
  if (DEBUG)
    {
      printf ("%s:%i:c_iflag=%04x c_oflag=%04x "
              "c_cflag=%04x c_lflag=%04x ",
              __FILE__, __LINE__,
              (int) msg.attr.c_iflag,
              (int) msg.attr.c_oflag,
              (int) msg.attr.c_cflag,
              (int) msg.attr.c_lflag);
      //
      for (c = 0; c < NCCS; c++)
        {
          printf ("c_cc[%i]=%02x ", c, (int) msg.attr.c_cc[c]);
        }
      printf ("\n");
    }
  //
  // System call.
  //
  sys (SYS_TCSETATTR, &msg, (sizeof msg));
  //
  errno = msg.errno;
  errln = msg.errln;
  strncpy (errfn, msg.errfn, PATH_MAX);
  return (msg.ret);
}
