#include <time.h>
#include <string.h>
#include <stdio.h>
//----------------------------------------------------------------------
static int leap_year (int year);
//----------------------------------------------------------------------
time_t
mktime (const struct tm *timeptr)
{
    time_t timer_total;
    time_t timer_aux;
    int    days;
    int    month;
    int    year;
    //
    // From seconds to days.
    //
    timer_total  = timeptr->tm_sec;
    //
    timer_aux    = timeptr->tm_min;
    timer_aux   *= 60;
    timer_total += timer_aux;
    //
    timer_aux    = timeptr->tm_hour;
    timer_aux   *= (60 * 60);
    timer_total += timer_aux;
    //
    timer_aux    = timeptr->tm_mday;
    timer_aux   *= 24;
    timer_aux   *= (60 * 60);
    timer_total += timer_aux;
    //
    // Month: add the days of months.
    // Will scan the months, from the first, but before the
    // months of the value inside field `tm_mon'.
    //
    for (month = 1, days = 0; month < timeptr->tm_mon; month++)
      {
        switch (month)
          {
            case 1:
            case 3:
            case 5:
            case 7:
            case 8:
            case 10:
                //
                // There is no December, because the scan can go up to
                // the month before the value inside field `tm_mon'.
                //
                days += 31;
                break;
            case 4:
            case 6:
            case 9:
            case 11:
                days += 30;
                break;
            case 2:
                if (leap_year (timeptr->tm_year))
                  {
                    days += 29;
                  }
                else
                  {
                    days += 28;
                  }
                break;
          }
      }
    //
    timer_aux    = days;
    timer_aux   *= 24;
    timer_aux   *= (60 * 60);
    timer_total += timer_aux;
    //
    // Year. The work is similar to the one of months: days of
    // years are counted, up to the year before the one reported
    // by the field `tm_year'.
    //
    for (year = 1970, days = 0; year < timeptr->tm_year; year++)
      {
        if (leap_year (year))
          {
            days += 366;
          }
        else
          {
            days += 365;
          }
      }
    //
    // After all, must subtract a day from the total.
    //
    days--;
    //
    timer_aux    = days;
    timer_aux   *= 24;
    timer_aux   *= (60 * 60);
    timer_total += timer_aux;
    //
    // That's all.
    //
    return (timer_total);
}
//----------------------------------------------------------------------
int
leap_year (int year)
{
    if ((year % 4) == 0)
      {
        if ((year % 100) == 0)
          {
            if ((year % 400) == 0)
              {
                return (1);
              }
            else
              {
                return (0);
              }
          }
        else
          {
            return (1);
          }
      }
    else
      {
        return (0);
      }
}
