#ifndef _UNISTD_H
#define _UNISTD_H       1
//----------------------------------------------------------------------
#include <sys/stat.h>
//#include <sys/os32.h> // !!!!!!!!!!!!!!! perché era qui??????
#include <sys/types.h>  // size_t, ssize_t, uid_t, gid_t, off_t, pid_t
#include <inttypes.h>   // intptr_t
#include <SEEK.h>       // SEEK_CUR, SEEK_SET, SEEK_END
//----------------------------------------------------------------------
typedef unsigned int useconds_t; // This type should be used for the
                                 // obsolete function `usleep()', that
                                 // is only implemented inside the
                                 // kernel, as `k_usleep()', for the
                                 // drivers management.
//----------------------------------------------------------------------
extern char **environ;  // Variable `environ' is used by functions like
                        // `execv()' in replacement for `envp[][]'.
//----------------------------------------------------------------------
extern char *optarg;    // Used by `optarg()'.
extern int   optind;    //
extern int   opterr;    //
extern int   optopt;    //
//----------------------------------------------------------------------
#define STDIN_FILENO    0       //
#define STDOUT_FILENO   1       // Standard file descriptors.
#define STDERR_FILENO   2       //
//----------------------------------------------------------------------
#define R_OK            4       // Read permission.
#define W_OK            2       // Write permission.
#define X_OK            1       // Execute or traverse permission.
#define F_OK            0       // File exists.
//----------------------------------------------------------------------

int          access      (const char *path, int mode);
int          brk         (void *address);
int          chdir       (const char *path);
int          chown       (const char *path, uid_t uid, gid_t gid);
int          close       (int fdn);
int          dup         (int fdn_old);
int          dup2        (int fdn_old, int fdn_new);
int          execl       (const char *path, char *arg, ...);
int          execle      (const char *path, char *arg, ...);
int          execlp      (const char *path, char *arg, ...);
int          execv       (const char *path, char *const argv[]);
int          execve      (const char *path, char *const argv[],
                          char *const envp[]);
int          execvp      (const char *path, char *const argv[]);
void        _exit        (int status);
int          fchown      (int fdn, uid_t uid, gid_t gid);
pid_t        fork        (void);
char        *getcwd      (char *buffer, size_t size);
gid_t        getegid     (void);
uid_t        geteuid     (void);
gid_t        getgid      (void);
int          getopt      (int argc, char *const argv[],
                          const char *optstring);
pid_t        getpgrp     (void);
pid_t        getppid     (void);
pid_t        getpid      (void);
uid_t        getuid      (void);
int          isatty      (int fdn);
int          link        (const char *path_old, const char *path_new);
off_t        lseek       (int fdn, off_t offset, int whence);
#define      nice(n)     (0)
int          pipe        (int pipefd[2]);
ssize_t      read        (int fdn, void *buffer, size_t count);
#define      readlink(p,b,s) ((ssize_t) -1)
int          rmdir       (const char *path);
void        *sbrk        (intptr_t increment);
int          setegid     (gid_t gid);
int          seteuid     (uid_t uid);
int          setgid      (gid_t gid);
int          setpgrp     (void);
int          setuid      (uid_t uid);
unsigned int sleep       (unsigned int s);
#define      sync()      /**/
char        *ttyname     (int fdn);
int          unlink      (const char *path);
ssize_t      write       (int fdn, const void *buffer, size_t count);
//----------------------------------------------------------------------
#endif
