#include <unistd.h>
#include <string.h>
#include <sys/os32.h>
#include <errno.h>
#include <limits.h>
//----------------------------------------------------------------------
int
rmdir (const char *path)
{
    sysmsg_stat_t   msg_stat;
    sysmsg_unlink_t msg_unlink;
    //
    if (path == NULL)
      {
        errset (EINVAL);
        return (-1);
      }
    //
    strncpy (msg_stat.path, path, PATH_MAX);
    //
    sys (SYS_STAT, &msg_stat, (sizeof msg_stat));
    //
    if (msg_stat.ret != 0)
      {
	errno = msg_stat.errno;
        errln = msg_stat.errln;
	strncpy (errfn, msg_stat.errfn, PATH_MAX);
        return (msg_stat.ret);
      }
    //
    if (!S_ISDIR (msg_stat.stat.st_mode))
      {
        errset (ENOTDIR);		// Not a directory.
        return (-1);
      }
    //
    strncpy (msg_unlink.path, path, PATH_MAX);
    //
    sys (SYS_UNLINK, &msg_unlink, (sizeof msg_unlink));
    //
    errno = msg_unlink.errno;
    errln = msg_unlink.errln;
    strncpy (errfn, msg_unlink.errfn, PATH_MAX);
    return (msg_unlink.ret);
}
