.extern main
.extern _stdio_stream_setup
.extern _dirent_directory_stream_setup
.extern _atexit_setup
.extern _environment_setup
.global startup
.global _data_end
#-----------------------------------------------------------------------
# Please note that, all segment descriptors are already set from the
# scheduler, and there is also data inside the stack, so that the call
# to `main()' function will result as expected.
#-----------------------------------------------------------------------
# The following statement says that the code will start at "startup"
# label.
#-----------------------------------------------------------------------
.section .text
#-----------------------------------------------------------------------
startup:  
    #
    # Jump after initial data.
    #
    jmp startup_code
    #
filler:
    #
    # After four bytes, from the start, there is the
    # magic number and other data.
    #
    .space (0x0004 - (filler - startup))
    #
magic:
    .quad 0x6F7333326170706C   # os32appl
    ;
doffset:                #
    .int _text_start    # Data offset from start.
etext:                  #
    .int _text_end      # End of code
edata:                  # 
    .int _data_end      # End of initialized data.
ebss:                   #
    .int _bss_end       # End of not initialized data.
stack_size:             #
    .int 0x8000         # Requested stack size. Every single application
                        # might change this value.
    #
    # At the next label, the work begins.
    #
.align 4
startup_code:
    #
    # Before the call to the main function, it is necessary to extract
    # the value to assign to the global variable `environ'. It is
    # described as `char **environ' and should contain the same address
    # pointed by `envp'. To get this value, the stack is popped and then
    # pushed again. Please recall that the stack was prepared from
    # the process management, at the `exec()' system call.
    #
    pop %eax		# argc
    pop %ebx		# argv
    pop %ecx		# envp
    mov %ecx, environ	# Variable `environ' comes from <unistd.h>.
    push %ecx
    push %ebx
    push %eax
    #
    # Could it be enough? Of course not! To be able to handle the
    # environment, it must be copied inside the table
    # `_environment_table[][]', that is defined inside <stdlib.h>.
    # To copy the environment it is used the function
    # `_environment_setup()', passing the `envp' pointer.
    #
    push %ecx
    call _environment_setup
    add  $4, %esp
    #
    # After the environment copy is done, the value for the traditional
    # variable `environ' is updated, to point to the new array of
    # pointer. The updated value comes from variable `_environment',
    # defined inside <stdlib.h>. Then, also the `argv' contained inside
    # the stack is replaced with the new value.
    #
    mov  $_environment, %eax
    mov  %eax, environ
    #
    pop %eax		# argc
    pop %ebx		# argv[][]
    pop %ecx		# envp[][]
    mov $_environment, %ecx
    push %ecx
    push %ebx
    push %eax
    #
    # Setup standard I/O streams and at-exit table.
    #
    call _stdio_stream_setup
    call _dirent_directory_stream_setup
    call _atexit_setup
    #
    # Call the main function. The arguments are already pushed inside
    # the stack.
    #
    call main
    #
    # Save the return value at the symbol `exit_value'.
    #
    mov  %eax, exit_value
    #
.align 4
halt:
    #
    pushl $2		# Size of message.
    pushl $exit_value	# Pointer to the message.
    pushl $6            # SYS_EXIT
    call sys
    add  $4, %esp
    add  $4, %esp
    add  $4, %esp
    #
    jmp halt
    #
#-----------------------------------------------------------------------
.align 4
.section .rodata
#
data_magic:
    .quad 0x6F73333264617461   # os32data [1]
#
_data_end:
    .int _bss_end
#
# [1] This is placed here just to be the same as the other file
#     `crt0.sep.s'. See the other file for an explanation.
#-----------------------------------------------------------------------
.align 4
.section .data
#
exit_value:
    .int 0x00000000
#-----------------------------------------------------------------------
.align 4
.section .bss
